require "MoneyConversion/version"

class Money
    include Comparable
    attr_accessor :currency, :amount
    @@hash = {}
    @@main_currency

    def initialize(amount, currency)
      @currency = currency
      @amount = amount
    end

    def self.main_currency
      @@main_currency
    end

    def self.hash
      @@hash
    end

    def convert_to(currency)
      Money.new(@@hash[currency]*@amount  ,currency )
    end

    def self.conversion_rates(main_currency, hash)
      @@main_currency = main_currency
      @@hash = hash
    end

    def <=> (other)
      if self.currency == other.currency
        self.amount <=> other.amount
      else
        puts (other.amount*(@@hash[other.currency]))
        self.amount <=> (other.amount/(@@hash[other.currency]))
      end
    end

    def +(other)
      if same_currency(self.currency, other.currency)
        Money.new(self.amount + other.amount, self.currency)
      else
        Money.new(self.amount + other.amount/@@hash[other.currency], self.currency)
      end
    end

    def -(other)
      if same_currency(self.currency, other.currency)
        Money.new(self.amount - other.amount, self.currency)
      else
        Money.new(self.amount - other.amount/@@hash[other.currency], self.currency)
      end
    end

    def *(factor)
      Money.new(self.amount * factor, self.currency)
    end

    def /(factor)
      Money.new(self.amount / factor, self.currency)
    end

    def same_currency(currency1, currency2)
      currency1 == currency2
    end
  end